#ifndef JNM_DECODING_PLAYER_H_
#define JNM_DECODING_PLAYER_H_

#include <jni.h>
#include <glib-object.h>
//#include <gst/interfaces/xoverlay.h>
#include <gst/video/videooverlay.h>
#include <jawt.h>
#include <linux/jawt_md.h>
#include "jnm_audiosink.h"

//#define USE_JAVASOUND 1
#ifdef __cplusplus
extern "C" {
#endif
JNIEXPORT jobject JNICALL Java_de_klausj_video_impl_gstreamer_GstMediaDecodingPlayer_init(JNIEnv *,jobject);
JNIEXPORT jlong JNICALL Java_de_klausj_video_impl_gstreamer_GstMediaDecodingPlayer_nativeWindowHandleX11Drawable(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_de_klausj_video_impl_gstreamer_GstMediaDecodingPlayer_configureVideoSink(JNIEnv *, jobject,jobject,jlong);
JNIEXPORT void JNICALL Java_de_klausj_video_impl_gstreamer_GstMediaDecodingPlayer_setVideoSinkWindow(JNIEnv *, jobject,jobject,jlong);
JNIEXPORT void JNICALL Java_de_klausj_video_impl_gstreamer_GstMediaDecodingPlayer_setAudioSink(JNIEnv *, jobject,jobject,jobject);
JNIEXPORT void JNICALL Java_de_klausj_video_impl_gstreamer_GstMediaDecodingPlayer_gMainLoopRun(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_de_klausj_video_impl_gstreamer_GstMediaDecodingPlayer_open(JNIEnv *, jobject,jobject,jstring);
JNIEXPORT void JNICALL Java_de_klausj_video_impl_gstreamer_GstMediaDecodingPlayer_start(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_de_klausj_video_impl_gstreamer_GstMediaDecodingPlayer_stop(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_de_klausj_video_impl_gstreamer_GstMediaDecodingPlayer_frameStep(JNIEnv *, jobject,jobject,jlong);
JNIEXPORT jboolean JNICALL Java_de_klausj_video_impl_gstreamer_GstMediaDecodingPlayer_seek(JNIEnv *, jobject,jobject,jlong);
JNIEXPORT void JNICALL Java_de_klausj_video_impl_gstreamer_GstMediaDecodingPlayer_rewind(JNIEnv *, jobject,jobject);
JNIEXPORT jlong JNICALL Java_de_klausj_video_impl_gstreamer_GstMediaDecodingPlayer_getDuration(JNIEnv *, jobject,jobject);
JNIEXPORT jlong JNICALL Java_de_klausj_video_impl_gstreamer_GstMediaDecodingPlayer_getPosition(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_de_klausj_video_impl_gstreamer_GstMediaDecodingPlayer_close(JNIEnv *, jobject, jobject);
JNIEXPORT void JNICALL Java_de_klausj_video_impl_gstreamer_GstMediaDecodingPlayer_clear(JNIEnv *, jobject, jobject);
#ifdef __cplusplus
}
#endif



typedef struct _JnmDecodingPlayer        JnmDecodingPlayer;
typedef struct _JnmDecodingPlayerClass   JnmDecodingPlayerClass;

typedef struct _JnmDecodingPlayerPrivate JnmDecodingPlayerPrivate;

struct _JnmDecodingPlayerPrivate
{
	gchar *msg;
};


/* object */
struct _JnmDecodingPlayer
{
    GstObject parent_instance;
    /* public */
    JavaVM *javaVM;
    jclass jClassRef;
    volatile jweak javaObjRef;
    volatile jmethodID jRenderMethodId;
    volatile jweak imgBufferArr;
    gchar *uri;
    GstBin *play;
    GMainLoop *loop;
    pthread_t videoNativeThreadID;
    JnmAudioSink *audioSink;
    jobject xWindowCanvas;
    GstVideoOverlay *xoverlay;
    Drawable drawable;
    JNIEnv *env;

    /*< private >*/
    JnmDecodingPlayerPrivate *priv;

};

/* class */
struct _JnmDecodingPlayerClass
{
    GstObjectClass parent_class;

    /* class members */

    /* Virtual public method */
};

GType jnm_decodingplayer_get_type ();
gboolean jnm_decodingplayer_set_caps(JnmDecodingPlayer *filter,GstCaps *caps);
GstFlowReturn jnm_decodingplayer_show_frame(JnmDecodingPlayer*,GstBuffer  *);
gboolean jnm_decodingplayer_audiosink_open(JnmDecodingPlayer *,gint,gint,gint,gboolean,gint);
guint jnm_decodingplayer_audiosink_write(JnmDecodingPlayer *,gpointer, guint);
guint jnm_decodingplayer_audiosink_delay(JnmDecodingPlayer *);
void jnm_decodingplayer_audiosink_reset(JnmDecodingPlayer *);
jlong jnm_decodingplayer_getDuration(JnmDecodingPlayer *);
gboolean jnm_decodingplayer_audiosink_close(JnmDecodingPlayer *);

#endif
